AJS.$(document).ready(function() {

	var vacmanCalendar = null;
	var editEvent = null;
	var removeEvent = null;
	
	
	AJS.$("#addHolidayDialogName").keypress(function(event){
	    if(event.keyCode == 13){
	    	event.preventDefault();
	        $("#addHolidayDialogSubmit").click();
	        return false;
	    }
	});
	
	AJS.$("#editHolidayDialogName").keypress(function(event){
	    if(event.keyCode == 13){
	    	event.preventDefault();
	        $("#editHolidayDialogSubmit").click();
	        return false;
	    }
	});
	
	function showAddHolidayDialog(date) {
		if (date == null) {
			date = VM$.moment();
		}
		AJS.$("#addHolidayDialogName").val("");
		var day=date.format('YYYY-MM-DD');
		AJS.$("#addHolidayDialogDay").val(day);
		AJS.$("#addHolidayDialogDay").trigger("input");
		$("input[name=yearly][value='false']").prop("checked",true);
		AJS.dialog2("#addHolidayDialog").show();
		AJS.$("#addHolidayDialogName").focus();
	}
	
	function showEditHolidayDialog(calendarEvent) {
		editEvent = calendarEvent;
		AJS.$("#editHolidayDialogName").val(editEvent.title);
		var day=editEvent.start.format('YYYY-MM-DD');
		AJS.$("#editHolidayDialogDay").text(day);
		if (editEvent.yearly) {
			AJS.$("input[name=editYearly][value='true']").prop("checked",true);
		} else {
			AJS.$("input[name=editYearly][value='false']").prop("checked",true);
		}
		AJS.dialog2("#editHolidayDialog").show();
	}
	
	AJS.$("#editHolidayDialogSubmit").click(function(e) {
	    e.preventDefault();
	    AJS.dialog2("#editHolidayDialog").hide();

	    editEvent.title = AJS.$("#editHolidayDialogName").val();
	    editEvent.yearly = (AJS.$('input[name=editYearly]:checked').val()=="true");
	    editHoliday(editEvent);
	});
	
	AJS.$("#editHolidayDialogClose").click(function(e) {
	    e.preventDefault();
	    AJS.dialog2("#editHolidayDialog").hide();
	});
	
	AJS.$("#removeHolidayDialogOpen").click(function(e) {
		e.preventDefault();
		removeEvent = editEvent;
		showRemoveHolidayDialog(removeEvent);
	});
	
	function showRemoveHolidayDialog(calendarEvent) {
		removeEvent = calendarEvent;
		var day=removeEvent.start.format('YYYY-MM-DD');
		var name=removeEvent.title;
		var yearly=removeEvent.yearly;
		if (yearly) {
			AJS.$("#removeHolidayOnetime").hide();
			AJS.$("#removeHolidayYearly").show();
		} else {
			AJS.$("#removeHolidayOnetime").show();
			AJS.$("#removeHolidayYearly").hide();
		}
		AJS.$("#removeHolidayDialogDay").text(day);
		AJS.$("#removeHolidayDialogName").text(name);
		
		AJS.dialog2("#editHolidayDialog").hide();
		AJS.dialog2("#removeHolidayDialog").show();
	}
	
	AJS.$("#removeHolidayDialogSubmit").click(function(e) {
	    e.preventDefault();
	    AJS.dialog2("#removeHolidayDialog").hide();

	    removeHoliday(removeEvent);
	});
	
	AJS.$("#removeHolidayDialogClose").click(function(e) {
	    e.preventDefault();
	    AJS.dialog2("#removeHolidayDialog").hide();
	});
	
	AJS.$("#addHolidayDialogSubmit").click(function(e) {
	    e.preventDefault();
	    AJS.dialog2("#addHolidayDialog").hide();
	    
	    var name = AJS.$("#addHolidayDialogName").val();
	    var yearly=($('input[name=yearly]:checked').val()=="true");
	    addHoliday(VM$.moment(AJS.$("#addHolidayDialogDay").val()), yearly, name);
	});
	
	AJS.$("#addHolidayDialogClose").click(function(e) {
	    e.preventDefault();
	    AJS.dialog2("#addHolidayDialog").hide();
	});
	
	function addHoliday(date, yearly, name) {
		var day=date.format('YYYY-MM-DD');
	
		jQuery.ajax({
			type: "PUT",
			url: AJS.contextPath() + "/rest/vacation-manager/1.0/holiday-management/settings/free-day?date="+day+"&desc="+name+"&yearly="+yearly,
			contentType: "application/json; charset=UTF-8",
			success: function(obj) {
				addHolidayOntoCalendar(obj.id, date, obj.yearly, obj.description);
				renderHolidaysTable();
			}
		});
	}
	
	function editHoliday(editEvent) {
		var day=editEvent.start.format('YYYY-MM-DD');
		
    	jQuery.ajax({
			type: "PUT",
			url: AJS.contextPath() + "/rest/vacation-manager/1.0/holiday-management/settings/free-day-edit?id="+editEvent.id+"&date="+day+"&desc="+editEvent.title+"&yearly="+editEvent.yearly,
			contentType: "application/json; charset=UTF-8",
			success: function(obj) {	
				vacmanCalendar.fullCalendar('removeEvents',obj.id);
				addHolidayOntoCalendar(obj.id, VM$.moment(obj.date), obj.yearly, obj.description);
				renderHolidaysTable();
			}
		});
    }
	
	function removeHoliday(removeEvent) {
    	jQuery.ajax({
			type: "DELETE",
			url: AJS.contextPath() + "/rest/vacation-manager/1.0/holiday-management/settings/free-day?id="+removeEvent.id,
			contentType: "application/json; charset=UTF-8",
			success: function() {	
				vacmanCalendar.fullCalendar('removeEvents',removeEvent.id);
				renderHolidaysTable();
			}
		});
    }
	
	function addHolidayOntoCalendar(id, date, yearly, title) {
		prepareEventObjects(id, date, yearly, title).forEach(function(event) {
			vacmanCalendar.fullCalendar('renderEvent', event, true);
		});
	}
	
	var uid = 0;
	
	function prepareEventObjects(id, date, yearly, title) {
		var events = new Array();
		if (yearly) {
			for (var year=2010; year<=2030; year++) { 
				var ndate = VM$.moment(date.year(year));
				var eventData = {
					id: id,
					uid: uid++,
					mainEvent: true,
					title: title,
					start: ndate,
					allDay: true,
					yearly: yearly,
					color: '#257e4a',
            		color: '#c8f1b9',
            		textColor: '#707070',
            		borderColor: '#257e4a'
				};
				events.push(eventData);
            	eventData = {
					id: id,
					mainEvent: false,
					start: ndate,
					allDay: true,
            		rendering: 'background',
            		color: '#f1bbbb'
        		};
            	events.push(eventData);
			}
		} else {
			var eventData = {
				id: id,
				uid: uid++,
				mainEvent: true,
				title: title,
				start: date,
				allDay: true,
				yearly: yearly,
        		color: '#c4ebff',
        		textColor: '#707070',
        		borderColor: '#3a87ad'
			};
			events.push(eventData);
        	eventData = {
				id: id,
				mainEvent: false,
				start: date,
				allDay: true,
        		rendering: 'background',
        		color: '#f1bbbb'
    		};
        	events.push(eventData);
		}
		return events;
	}
	
	function insertHolidays(holidays) {
		var events = new Array();
		holidays.forEach(function(holiday) {
			events = events.concat(prepareEventObjects(holiday.id, VM$.moment(holiday.date), holiday.yearly, holiday.title));
		});
		vacmanCalendar.fullCalendar( 'addEventSource', events );
	}

	function renderHolidaysTable() {
		AJS.$("#holidays-list").empty();
		var now = VM$.moment();
		var renderEvents = new Array();
		vacmanCalendar.fullCalendar('clientEvents', function(event) {
            if (event.start.year() == tableDate.year() && event.mainEvent == true) {
            	renderEvents.push({id:event.uid, start: event.start.format(), title: event.title, date: event.start,
            		yearly: event.yearly, past: event.start.isBefore(now), currentMonth: event.start.month() == tableDate.month()});
            }
            return false;
        });
		renderEvents.sort(function(a, b) {
			if (a.date > b.date) return 1;
			if (a.date < b.date) return -1;
			return 0;
		});
		AJS.$("#holidays-list").html(VacationManager.Templates.Holiday.ManageHolidays.holidaysTable({events:renderEvents}));
		
		AJS.$("[holiday-list-clickable]").click(function() {
			var date = vacmanCalendar.fullCalendar('getCalendar').moment(AJS.$(this).attr("date"));
			vacmanCalendar.fullCalendar( 'gotoDate', date );
		    $('html, body').animate({
		        scrollTop: $("#vacman-calendar").offset().top
		    }, 100);
		});

		AJS.$("[holiday-list-edit]").click(function(evt) {
			var eventId = AJS.$(this).attr("event-id");
			vacmanCalendar.fullCalendar('clientEvents').forEach(function(event) {
				if (event.uid == eventId) {
					showEditHolidayDialog(event);
					evt.preventDefault();
					evt.stopPropagation();
				}
			});
		});
		
		AJS.$("[holiday-list-add-new]").click(function(evt) {
			showAddHolidayDialog();
		});
	}

	var tableDate = null;

	vacmanCalendar = VM$('#vacman-calendar').fullCalendar({
		header: {
			left: 'addNew',
			center: 'prevYear,prev title next,nextYear',
			right: 'today'
		},
		firstDay: firstDay,
		aspectRatio: 1.7,
		businessHours: {dow: dow},
	    dayClick: function(date, jsEvent, view) {
	    	showAddHolidayDialog(date);
	    },
		eventClick: function(calEvent, jsEvent, view) {
			showEditHolidayDialog(calEvent);
		},
		viewRender: function(view, element) {
			if (vacmanCalendar != null && tableDate.diff(vacmanCalendar.fullCalendar('getDate')) != 0) {
				tableDate = vacmanCalendar.fullCalendar('getDate');
				renderHolidaysTable();
			}
		},
		customButtons: {
			addNew: {
	            text: AJS.I18n.getText("vacationmanager.action.holiday.holidays.add.label"),
	            click: function() {
	            	showAddHolidayDialog();
	            }
	        }
		}
	});
	
	insertHolidays(holidays);
	
	tableDate = vacmanCalendar.fullCalendar('getDate');
	renderHolidaysTable();

	AJS.$('.aui-date-picker').each(function() {
		AJS.$(this).datePicker({'overrideBrowserDefault': true});
	});

});
