AJS.$(document).ready(function() {
	AJS.$("#exportFiltered").click(function (event) {
		try {
			exportCsvAs(statisticsData, generateFileName(statisticsData));
		} catch (err) {
			alert(AJS.I18n.getText("vacationmanager.action.statistics.export.csv.error", err));
		}
		event.preventDefault();
		return false;
	});
	
	function generateFileName(statisticsObject) {
		return "statistics_" + statisticsObject.vacationKindName + "_" + statisticsObject.start + "_" + statisticsObject.end + ".csv";
	}
	
	function exportCsvAs(statisticsObject, fileName) {
		var table = statisticsObject.table;
		var rawData = "";

		var columns = new Array((AJS.I18n.getText("vacationmanager.action.statistics.export.csv.column.vacation.kind")));
		for (var id = 0; id < table.columns().count(); id++ ) {
			if (table.column(id).visible() == true) {
				columns.push(table.column(id).header().textContent);
			}
		}
		
		rawData += encodeCsvLine(columns);
		
		statisticsObject.table.$('tr', {"filter":"applied"}).each(function(index, rowNode) {
			var rowData = new Array(statisticsObject.vacationKindName);
			for (var col = 0; col < rowNode.children.length; col++) {
				rowData.push(rowNode.children[col].children[0].getAttribute("value"));
			}
			rawData += encodeCsvLine(rowData);
		});
		
		var blob = new Blob([rawData], {type: "text/plain;charset=utf-8"});
		saveAs(blob, fileName);
	}
	
	function encodeCsvLine(elements) {
		var line = "";
		elements.forEach(function(element) {
			line += "\"" + element + "\",";
		});
		line = line.substring(0, line.length - 1);
		line += "\r\n";
		return line;
	}
});
